//  ATMega8 Perseus - 3 Command module
//
//  (C) 2010 Radu Motisan , radu.motisan@gmail.com
//  www.pocketmagic.net
//  All rights reserved.
//


#include "globals.h"

int g_nMove = 0, g_nTurn = 0;

void uartRxHandler(unsigned char c)
{
	char xs[255] = {0};
	sprintf(xs, "[%c]\n\r",c);
	uartSendBuffer(xs, strlen(xs));

	if (c == 'w') g_nMove  = 1;
	if (c == 's') g_nMove  = -1;
	if (c == 'd') g_nTurn  = -1;
	if (c == 'a') g_nTurn  = 1;
	
}


int DigiPin(int ddr,int port, int pin, int status)
{
	if (status)
	{
		//activate port for output
		ddr |= (1<<pin);
		//activate pin
		port |= (1<<pin);
	}
	else
	{
		//deactivate pin
		port &= ~(1<<pin);
		//activate port for output
		ddr &= ~(1<<pin);
	}
	return 1;
}



int main(void)
{
	//general index
	int i=0;
	//
	
	DDRB |= 0x1E;

	LEDInit();
	LEDSet(1);

	timerInit(); // initialize the timer system
	
	a2dInit(); // initialize analog to digital converter (ADC)
	a2dSetPrescaler(ADC_PRESCALE_DIV32); // configure ADC scaling
	a2dSetReference(ADC_REFERENCE_AVCC); // configure ADC reference voltage

	//uart
	uartInit();  // initialize the UART (serial port)
	uartSetBaudRate(9600);// set the baud rate of the UART for our debug/reporting output
	uartSetRxHandler(uartRxHandler);
	uartSendBuffer("Serial on.\n\r",12);


//	PIRInit();//pc4

	//
	while(1)
	{
		delay_us(1000000);
		i++;
		if (i>255) i = 0;
		LEDSet(i%2); // flash the board led

		int nPINGL =  a2dConvert8bit(5); // info sensor PING front-left >0 means obstacle detected
		int nPINGR =  a2dConvert8bit(4); // info sensor PING front-right >0 means obstacle detected

		//PORT_ON(PORTB, 1);
		//PORT_ON(PORTB, 3);

		if (g_nMove == 1)
		{
			PORT_ON(PORTB, 1);
			PORT_ON(PORTB, 3);
			delay_us(2600000);
			PORT_OFF(PORTB, 1);
			PORT_OFF(PORTB, 3);
			g_nMove = 0;
		}
		if (g_nMove == -1)
		{
			PORT_ON(PORTB, 2);
			PORT_ON(PORTB, 4);
			delay_us(2600000);
			PORT_OFF(PORTB, 2);
			PORT_OFF(PORTB, 4);
			g_nMove = 0;
		}
		if (g_nTurn == 1)
		{
			PORT_ON(PORTB, 1);
			PORT_ON(PORTB, 4);
			delay_us(1500000);
			PORT_OFF(PORTB, 1);
			PORT_OFF(PORTB, 4);
			g_nTurn = 0;	
		}
		if (g_nTurn == -1)
		{
			PORT_ON(PORTB, 2);
			PORT_ON(PORTB, 3);
			delay_us(2000000);
			PORT_OFF(PORTB, 2);
			PORT_OFF(PORTB, 3);
			g_nTurn = 0;	
		}
		
	//char x[25] = {0};
	//	therm_read_temperature(x);

/*		//gather sensor data
		//int ping = GH311Status();
		
		//read temp pc5
		
		//read pir pc4
		int pir = PIRStatus();
		//read lumi pc3
		int avpc = a2dConvert8bit(3);
		
	
		//send over serial conn
		char xs[255] = {0};
		sprintf(xs, "%3d PIR:%d LUMI:%d Temp: %s\r\n",i, pir,avpc,x);
		uartSendBuffer(xs, strlen(xs));
		
		delay_us(1000000);
		*/
	/*	int ping = a2dConvert8bit(3);
		char xs[255] = {0};
		sprintf(xs, "%3d ping(PC3)=%d temp(PC2)=%s\n\r",i,ping,x);
		uartSendBuffer(xs,strlen(xs));*/
		

	/*	//FWD
		if (ping > 60)
		{
		PORT_ON(PORTB, 1);
		PORT_ON(PORTB, 3);
		delay_us(1600000);
		PORT_OFF(PORTB, 1);
		PORT_OFF(PORTB, 3);
		}
		else
		if (ping > 30)
		{
		//TURN
		PORT_ON(PORTB, 1);
		PORT_ON(PORTB, 4);
		delay_us(500000);
		PORT_OFF(PORTB, 1);
		PORT_OFF(PORTB, 4);
		}*/

		
	}
	return 0;


}
